(* -*-sml-*- *)

(* ----------------------------------------------------------------
 * This file contains some test cases for the interpreter
 * in "R" mode. This is ML type inference. All tests from s_test.f
 * except iso-recursive types and variants also work.
 *
 * author: Christian Mueller
 * -------------------------------------------------------------*)     


(* 1. standart examples: polymorphic identity function, ... *)

rdef id = \x.x

rdef id2 = \x.x

rdef inc = \x.x+1

rdef f = \x.\y.\f. if f x y then x else y

rdef result_11 = { int = id 3, bool = id true }

(* no ML-like value restriction, therefore no error message *)

rdef result_12 = id id 

rdef result_12 = inc 3

(* 
   2. anotation are still possible: 
      compare definition and use of the following definitions 
*)

rdef f0 = \g.\x. g x
rdef f1 = \g:'a->'a.\x. g x

rdef result_21 = f0 (\x:Bool.3)
rdef result_22 = f1 (\x:Int.x)

